    //
//  DetailViewController-iPad.m
//  UniTest2
//
//  Created by コザワ ノブミチ on 10/08/12.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "DetailViewController-iPad.h"
#import "RootViewController-iPad.h"

@interface DetailViewController_iPad ()
@property (nonatomic, retain) UIPopoverController *popoverController;
- (void)configureView;
@end

@implementation DetailViewController_iPad

@synthesize toolBar, popoverController, detailItem, textView;

- (void)setDetailItem:(id)newDetailItem {
	if (detailItem != newDetailItem) {
		[detailItem release];
		detailItem = [newDetailItem retain];
		
		[self configureView];
	}
	
	if (popoverController != nil) {
		[popoverController dismissPopoverAnimated:YES];
	}
}

- (void)configureView {
	textView.text = [detailItem description];
}

- (void)splitViewController:(UISplitViewController*)svc willHideViewController:(UIViewController *)aViewController withBarButtonItem:(UIBarButtonItem*)barButtonItem forPopoverController:(UIPopoverController*)pc {
	barButtonItem.title = @"Root List";
	NSMutableArray *items = [[toolBar items] mutableCopy];
	[items insertObject:barButtonItem atIndex:0];
	[toolBar setItems:items animated:YES];
	[items release];
	self.popoverController = pc;
}

- (void)splitViewController:(UISplitViewController*)svc willShowViewController:(UIViewController *)aViewController invalidatingBarButtonItem:(UIBarButtonItem *)button {
	NSMutableArray *items = [[toolBar items] mutableCopy];
	[items removeObjectAtIndex:0];
	[toolBar setItems:items animated:YES];
	[items release];
	self.popoverController = nil;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Overriden to allow any orientation.
    return YES;
}


- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[popoverController release];
	[toolBar release];
	
	[detailItem release];
	[textView release];
    [super dealloc];
}


@end
